#include <Arduino.h>
#include <Altino.h>
#include <math.h>
#include <MsTimer2.h>
unsigned char tx_d[28] = { 0, };
//unsigned char tx_d1[22] = { 0, };

volatile static unsigned char Sendbuf[28] = {0,};
//volatile static unsigned char Sendbuf2[22] = { 0, };

unsigned char rx_data[100]= { 0, };
unsigned char rx_d56[56]= { 0, };
long rx_d_sensor1[56] = { 0, };
int len = 0;
long rxcnt=0;

extern Altino sensor;
void SendData(unsigned char *Sendbuf1);
void AltinoTimer()
{
    SendData(Sendbuf);
    sensor=SensorFun(10);

}

void Open()
{
    Serial.begin(115200);
    MsTimer2::set(50,AltinoTimer);
    MsTimer2::start();
    Sound(0);
    Go(0,0);
    Steering(0);
    Display(0);
    Led(0);
    delay(500);
}

void bt()
{
    Open();
}

void Bt()
{
    Open();
}

unsigned char check_sum_tx_calcuration(int u16_cnt)
{
  int u16_tx_check_sum = 0;
  int u16_tx_cnt;
  u16_tx_check_sum = u16_tx_check_sum + tx_d[1];
  for (u16_tx_cnt = 3; u16_tx_cnt <= u16_cnt; u16_tx_cnt++) {
    u16_tx_check_sum = u16_tx_check_sum + tx_d[u16_tx_cnt];
  }
  u16_tx_check_sum = u16_tx_check_sum % 256;
  return (byte)(u16_tx_check_sum);
}

void SendData(unsigned char *Sendbuf1)
{

  int k;
  tx_d[0] = 0x2;
  tx_d[1] = 28;

  tx_d[3] = 1;
  tx_d[4] = 10;
  tx_d[5] = Sendbuf1[5];
  tx_d[6] = Sendbuf1[6];
  tx_d[7] = Sendbuf1[7];
  tx_d[8] = Sendbuf1[8];
  tx_d[9] = Sendbuf1[9];
  tx_d[10] = Sendbuf1[10];
  tx_d[11] = Sendbuf1[11];
  tx_d[12] = Sendbuf1[12];
  tx_d[13] = Sendbuf1[13];
  tx_d[14] = Sendbuf1[14];
  tx_d[15] = Sendbuf1[15];
  tx_d[16] = Sendbuf1[16];
  tx_d[17] = Sendbuf1[17];
  tx_d[18] = Sendbuf1[18];
  tx_d[19] = Sendbuf1[19];
  tx_d[20] = Sendbuf1[20];
  tx_d[21] = Sendbuf1[21] | 0x01;
  tx_d[22] = Sendbuf1[22];
  tx_d[23] = Sendbuf1[23];
  tx_d[24] = Sendbuf1[24];
  tx_d[25] = Sendbuf1[25];
  tx_d[26] = 255;
  tx_d[27] = 0x3;

  tx_d[2] = check_sum_tx_calcuration(27);
  Serial.write(tx_d, 28);
}

void Go(int left, int right)
{
    unsigned int temp=32768;
    unsigned int left_int, right_int;

    if (left < 0) {
        left_int = temp - left;
    }
    else{
        left_int = left;
    }

    if (right<0){
        right_int = temp - right;
    }
    else {
        right_int=right;
    }

    Sendbuf[6] = 0;
    Sendbuf[9] = 0;
    Sendbuf[7] = (byte)(right_int / 256);
    Sendbuf[8] = (byte)(right_int % 256);
    Sendbuf[10] = (byte)(left_int / 256);
    Sendbuf[11] = (byte)(left_int % 256);

}

void go(int left, int right)
{
    Go(left,right);
}

void Steering(int value)
{
    if(value>127)
		value=127;

	if(value<-127)
		value=-127;

	if(value<0)
		value=128-value;

	Sendbuf[5] = (byte)value;
	Sendbuf[24] = 1;
	Sendbuf[25] = (byte)0;
}

void steering(int value)
{
	Steering(value);
}

void Sound(unsigned char buzzer)
{
	Sendbuf[27] = 0;
	Sendbuf[22] = (byte)buzzer;
}

void sound(unsigned char buzzer)
{
	Sound(buzzer);
}

void Display(unsigned char ASCII)
{
    if(ASCII>128)
    {
        ASCII = ASCII-128;
    }
    else if(ASCII>0 && ASCII <128)
    {
        ASCII = 128+ ASCII;
    }

    Sendbuf[12] = ASCII;
	Sendbuf[13] = 0;
	Sendbuf[14] = 0;
	Sendbuf[15] = 0;
	Sendbuf[16] = 0;
	Sendbuf[17] = 0;
	Sendbuf[18] = 0;
	Sendbuf[19] = 0;
	Sendbuf[20] = 0;
}

void display(unsigned char ASCII)
{
    Display(ASCII);
}

void DisplayLine(unsigned char dot0, unsigned char dot1, unsigned char dot2, unsigned char dot3, unsigned char dot4, unsigned char dot5, unsigned char dot6, unsigned char dot7)
{
    unsigned char ASCII=0;
    if(ASCII>128)
    {
        ASCII = ASCII-128;
    }
    else if(ASCII>0 && ASCII <128)
    {
        ASCII = 128+ ASCII;
    }

    Sendbuf[12] = ASCII;
	Sendbuf[13] = dot7;
	Sendbuf[14] = dot6;
	Sendbuf[15] = dot5;
	Sendbuf[16] = dot4;
	Sendbuf[17] = dot3;
	Sendbuf[18] = dot2;
	Sendbuf[19] = dot1;
	Sendbuf[20] = dot0;
}

void displayline(unsigned char dot0, unsigned char dot1, unsigned char dot2, unsigned char dot3, unsigned char dot4, unsigned char dot5, unsigned char dot6, unsigned char dot7)
{
	DisplayLine(dot0,dot1,dot2,dot3,dot4,dot5,dot6,dot7);
}

void displayLine(unsigned char dot0, unsigned char dot1, unsigned char dot2, unsigned char dot3, unsigned char dot4, unsigned char dot5, unsigned char dot6, unsigned char dot7)
{
	DisplayLine(dot0,dot1,dot2,dot3,dot4,dot5,dot6,dot7);
}

void Displayon(int x, int y)
{
    unsigned char dotx;
	Sendbuf[12] = 0;
	dotx=Sendbuf[21-x];

    Sendbuf[21-x] = dotx | (unsigned char)(0x01<<(y-1));
}

void displayon(int x, int y)
{
    Displayon(x, y);
}

void displayOn(int x, int y)
{
    Displayon(x, y);
}

void DisplayOn(int x, int y)
{
    Displayon(x, y);
}

void DisplayON(int x, int y)
{
    Displayon(x, y);
}

void Displayoff(int x, int y)
{
    unsigned char dotx;
	Sendbuf[12] = 0;
	dotx=Sendbuf[21-x];

    Sendbuf[21-x] = dotx & ((unsigned char)(255-(0x01<<y-1)));
}

void displayoff(int x, int y)
{
    Displayoff(x, y);
}

void displayOff(int x, int y)
{
    Displayoff(x, y);
}

void DisplayOff(int x, int y)
{
    Displayoff(x, y);
}

void DisplayOFF(int x, int y)
{
    Displayoff(x, y);
}

void Led(long led)
{
	Sendbuf[23] = (byte)(led%256);
	Sendbuf[21] = (byte)(led/256);
}

void led(long led)
{
	Led(led);
}

void Light(long led)
{
    Led(led);
}

void light(long led)
{
    Led(led);
}

void Stop()
{
    Go(0,0);Steering(0);
    Sound(0);Led(0);
    Display(0);
}

void stop()
{
    Stop();
}

Altino SensorFun(int command)
{
	Altino sensordata1;
	long i,j;

    while(1)
    {
        if(Serial.available()>0){
            rx_data[rxcnt]=Serial.read();
            rxcnt++;

        }
        else {
            break;
        }
    }

    for(i=0; i<rxcnt; i++) {
        for(j=0; j<55; j++) {
            rx_d56[j]=rx_d56[j+1];
        }
        rx_d56[55]=rx_data[i];
        long rx_check_sum=0;

        if ((rx_d56[0] == 2) && (rx_d56[55] == 3) && (rx_d56[1] == 56))
        {
            rx_check_sum = rx_d56[0];
            rx_check_sum = rx_check_sum + rx_d56[1];
            for(int i=3; i<56; i++)
            {
                rx_check_sum = rx_check_sum + rx_d56[i];
            }
            rx_check_sum = rx_check_sum % 256;

            if (rx_check_sum==rx_d56[2])
            {
                for(int i=7; i<54; i++)
                {
                    rx_d_sensor1[i] = rx_d56[i];
                }
                for(int i=0; i<56; i++) rx_d56[i]=0;
            }
        }
    }
    rxcnt=0;

    Serial.flush();

	sensordata1.IR[1] = rx_d_sensor1[7] * 256 + rx_d_sensor1[8];
	sensordata1.IR[2] = rx_d_sensor1[9] * 256 + rx_d_sensor1[10];
	sensordata1.IR[3] = rx_d_sensor1[11] * 256 + rx_d_sensor1[12];
	sensordata1.IR[4] = rx_d_sensor1[13] * 256 + rx_d_sensor1[14];
	sensordata1.IR[5] = rx_d_sensor1[15] * 256 + rx_d_sensor1[16];
	sensordata1.IR[6] = rx_d_sensor1[17] * 256 + rx_d_sensor1[18];

	sensordata1.MCur[0] = rx_d_sensor1[19] * 256 + rx_d_sensor1[20];
	sensordata1.MCur[1] = rx_d_sensor1[21] * 256 + rx_d_sensor1[22];
	sensordata1.Temp = rx_d_sensor1[49] * 256 + rx_d_sensor1[50];

	sensordata1.CDS = rx_d_sensor1[43] * 256 + rx_d_sensor1[44];

	sensordata1.Acc[0] = (long)rx_d_sensor1[25] * 256 + (long)rx_d_sensor1[26];
	sensordata1.Acc[1] = (long)rx_d_sensor1[27] * 256 + (long)rx_d_sensor1[28];
	sensordata1.Acc[2] = (long)rx_d_sensor1[29] * 256 + (long)rx_d_sensor1[30];

	long temp=0;

	temp=sensordata1.Acc[0]/16;
	sensordata1.Acc[0]=temp;
	if(temp>2048) sensordata1.Acc[0]=sensordata1.Acc[0]-4096;

	temp=sensordata1.Acc[1]/16;
	sensordata1.Acc[1]=temp;
	if(temp>2048) sensordata1.Acc[1]=sensordata1.Acc[1]-4096;

	temp=sensordata1.Acc[2]/16;
	sensordata1.Acc[2]=temp;
	if(temp>2048) sensordata1.Acc[2]=sensordata1.Acc[2]-4096;

	sensordata1.Mag[0] = (long)rx_d_sensor1[31] * 256 + (long)rx_d_sensor1[32];
	sensordata1.Mag[1] = (long)rx_d_sensor1[33] * 256 + (long)rx_d_sensor1[34];
	sensordata1.Mag[2] = (long)rx_d_sensor1[35] * 256 + (long)rx_d_sensor1[36];

	sensordata1.StVar = rx_d_sensor1[45] * 256 + rx_d_sensor1[46];
	sensordata1.StCur = rx_d_sensor1[23] * 256 + rx_d_sensor1[24];
	sensordata1.Bat = rx_d_sensor1[47] * 256 + rx_d_sensor1[48];
    sensordata1.Remote = rx_d_sensor1[51] * 256 + rx_d_sensor1[52];

	sensordata1.Gyro[0] = (long)rx_d_sensor1[37]*256 +(long)rx_d_sensor1[38];
	sensordata1.Gyro[1] = (long)rx_d_sensor1[39] * 256 + (long)rx_d_sensor1[40];
	sensordata1.Gyro[2] = (long)rx_d_sensor1[41] * 256 + (long)rx_d_sensor1[42];

	if(sensordata1.Acc[0]>32768)
        sensordata1.Acc[0]=sensordata1.Acc[0]-65535;

    if(sensordata1.Acc[1]>32768)
        sensordata1.Acc[1]=sensordata1.Acc[1]-65535;

	if(sensordata1.Acc[2]>32768)
        sensordata1.Acc[2]=sensordata1.Acc[2]-65535;

    if(sensordata1.Mag[0]>32768)
        sensordata1.Mag[0]=sensordata1.Mag[0]-65535;

    if(sensordata1.Mag[1]>32768)
        sensordata1.Mag[1]=sensordata1.Mag[1]-65535;

    if(sensordata1.Mag[2]>32768)
        sensordata1.Mag[2]=sensordata1.Mag[2]-65535;

    if(sensordata1.Gyro[0]>32768)
        sensordata1.Gyro[0]=sensordata1.Gyro[0]-65535;

    if(sensordata1.Gyro[1]>32768)
        sensordata1.Gyro[1]=sensordata1.Gyro[1]-65535;

	if(sensordata1.Gyro[2]>32768)
        sensordata1.Gyro[2]=sensordata1.Gyro[2]-65535;

	return sensordata1;
}
